function reteout = Riadatrxqos (rete,x,y,a,b);


N=15; % Dimensione della Rete UWB
M=30; % N max di comunicazioni contemporanee attive in un nodo
R=10; % Raggio della cella UWB
SINR_RIF_QoS= 25.1188643151; % 14db
SINR_RIF_BE= 15.84893192461; % 12db
DELTA= 1.584893192461; % 2db -  il margine da aggiungere, sul singolo setup, al SINR_RIF
mp2=3.05e-20;
o2=6.045e-30;
N0mp=7.2336e-31;
Ew=1.079e-10;
%Plim=12e-3; % Potenza max. uscente dal nodo (vedi limite FCC)
%Psegn=6e-3;
%Pnmax=6e-3;
Rmin=10e3; % Rate minimo per tx di tipo BE
PAR_ALFA=1; % Vedi riadattamento rate al rx



for k=max(1,a-R):min(N,a+R)
	for h=max(1,b-R):min(N,b+R)
   	if (rete(k,h)==1 | rete(k,h)==2 | rete(k,h)==3) & distanza(k,h,a,b)<=R & distanza(k,h,x,y)~=0 & distanza(k,h,a,b)~=0
      	for m=1:M
         	if rete(k,h,m,1)==2 
             % Procedura riadattamento rate al rx
            	if rete(k,h,m,5)==2 & rete(k,h,m,11)==0
               	rete(k,h,m,7)=rete(k,h,m,7)*(1-(PAR_ALFA/distanza(k,h,a,b)));
                  Ra=(rete(k,h,m,7)*mp2*guadagno(k,h,rete(k,h,m,2),rete(k,h,m,3)))/(SINR_RIF_BE*DELTA*(N0mp*Ew+o2*rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),9)));
                  rete(k,h,m,8)=Ra; % Cos ho cambiato Pot. e Rate al tx BE
                  if Ra < Rmin
                     rete(k,h,m,7)=0;
                     fprintf('Abbatto virtualmente la comunicazione tra %d %d e %d %d\n',k,h,rete(k,h,m,2),rete(k,h,m,3));
                  else
                     fprintf('Ho ridotto virtualmente potenza e rate della comunicazione tra %d %d e %d %d\n',k,h,rete(k,h,m,2),rete(k,h,m,3));
                  end
               elseif rete(k,h,m,5)==2 & (rete(k,h,m,11)==1 | rete(k,h,m,11)==3)
                  rete(k,h,m,7)=rete(k,h,m,7)*(1-(PAR_ALFA/distanza(k,h,a,b)));
                  Ra=(rete(k,h,m,7)*mp2*guadagno(k,h,rete(k,h,m,2),rete(k,h,m,3)))/(SINR_RIF_BE*DELTA*(N0mp*Ew+o2*rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),9)));
                  rete(k,h,m,8)=Ra;
                  % Cos ho cambiato Pot. e Rate al tx BE
                  %Mentre al tx BE del Mh solo il Rate, non dovrebbe dare problemi tanto la potenza e` maggiore
                  rete(rete(k,h,m,12),rete(k,h,m,13),rete(k,h,m,14),8)=Ra;
                  
                  if Ra < Rmin
                     rete(k,h,m,7)=0;
                     rete(rete(k,h,m,12),rete(k,h,m,13),rete(k,h,m,14),7)=0;
                  end
               end % Fine procedura riadattamento rate al rx
            end
         end
      end
   end
end
fprintf('Se il riadattamento non andr a buon fine verranno ripristinati i valori della comunicazione\n');
reteout=rete;